SystemOrganization addCategory: #SwazooSpike!

SwazooResource subclass: #S2JWebApp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SwazooSpike'!

S2JWebApp class
	instanceVariableNames: 'globalResponseId isServing responseContent sessions'!

!S2JWebApp commentStamp: 'ag 1/9/2011 17:09' prior: 0!
Code-Snippets (S2JWebApp can be replaced with any subclass)
	
	S2JWebApp writeSiteTo: 'C:\users\abc\Desktop\squeak.html'.
	S2JWebApp recompileRequiredClasses. "Recompiles only the required classes (including superclasses) of this WebApp, not of super-web-apps"
	!

S2JWebApp class
	instanceVariableNames: 'globalResponseId isServing responseContent sessions'!

S2JWebApp subclass: #S2JGraphicsApp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SwazooSpike'!

S2JGraphicsApp subclass: #S2JBouncingBallsApp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SwazooSpike'!

!S2JBouncingBallsApp class methodsFor: 'configuration' stamp: 'ag 1/10/2011 12:13'!
codeFactory
	
	^ S2JPrettyCodeFactory! !

!S2JBouncingBallsApp class methodsFor: 'configuration' stamp: 'ag 1/3/2011 17:22'!
defaultPort
	
	^ 8886! !

!S2JBouncingBallsApp class methodsFor: 'rendering javascript' stamp: 'ag 1/8/2011 17:05'!
requiredClasses
	
	^ { S2JBall. S2JBallGame }! !

!S2JBouncingBallsApp class methodsFor: 'configuration' stamp: 'ag 1/3/2011 17:33'!
siteName
	
	^ 'bouncingBalls'! !

!S2JGraphicsApp class methodsFor: 'rendering javascript' stamp: 'ag 1/8/2011 17:05'!
requiredClasses
	
	^ { Rectangle. Point }! !

!S2JGraphicsApp methodsFor: 'rendering' stamp: 'ag 1/11/2011 17:22'!
externalJavascriptUrlsAfterClasses
	
	^ super externalJavascriptUrlsAfterClasses, #( 'canvastoolkit.js' 'additional_functions.js' )! !

!S2JGraphicsApp methodsFor: 'rendering' stamp: 'ag 1/8/2011 17:01'!
renderAdditionalContent
	
	^ '<canvas id="ballCanvas" width="400" height="300" style="background-color: #ffffff; border: solid 1px #000000;"></canvas>'! !

!S2JWebApp class methodsFor: 'rendering javascript' stamp: 'ag 1/9/2011 14:10'!
allRequiredClasses
	"Return the requiredClasses together with all their superclasses. Only for this class, not the superclasses."
	
	| allClasses |
	allClasses := OrderedCollection new.
	self requiredClasses do: [ :eachClass |
		eachClass allSuperclasses reverseDo: [ :superClass |
			(allClasses includes: superClass) ifFalse: [ allClasses add: superClass ]].
		(allClasses includes: eachClass) ifFalse: [ allClasses add: eachClass ]].
	^ allClasses! !

!S2JWebApp class methodsFor: 'configuration' stamp: 'HK 12/1/2010 20:47'!
applicationPath

	^ '/app'.! !

!S2JWebApp class methodsFor: 'rendering javascript' stamp: 'ag 1/6/2011 22:23'!
codeFactory
	
	^ S2JCodeFactory
	"^ S2JPrettyCodeFactory"! !

!S2JWebApp class methodsFor: 'rendering javascript' stamp: 'ag 1/9/2011 14:16'!
codeForAllClasses
	
	^ self codeFactory codeForClasses: self collectRequiredClasses! !

!S2JWebApp class methodsFor: 'rendering javascript' stamp: 'ag 1/9/2011 14:30'!
collectRequiredClasses
	"Collect #requiredClasses from all superclasses. Trickier than I thought :("
	
	| class result superClasses |
	result := OrderedCollection new.
	superClasses := S2JWebApp allSuperclasses.
	class := self.
	[ superClasses includes: class ]
		whileFalse: [
			result addAll: class allRequiredClasses.
			class := class superclass ].
	^ result
		inject: OrderedCollection new
		into: [ :all :cl | (all includes: cl) ifFalse: [ all add: cl ]. all ]! !

!S2JWebApp class methodsFor: 'rendering javascript' stamp: 'LT 1/11/2011 18:06:42.316'!
defaultJavascriptBaseUrl
	
	^ 'https://github.com/bp2010h1/squeakyJS/raw/master/'! !

!S2JWebApp class methodsFor: 'rendering javascript' stamp: 'LT 1/11/2011 17:43:33.211'!
defaultJavascriptGraphicsUrl

	^ 'http://dev.sencha.com/deploy/dev/'! !

!S2JWebApp class methodsFor: 'configuration' stamp: 'HK 12/7/2010 18:05'!
defaultMillisecondsToWait

	^ 100.! !

!S2JWebApp class methodsFor: 'configuration' stamp: 'HK 12/2/2010 11:27'!
defaultPort

	^ 8887! !

!S2JWebApp class methodsFor: 'configuration' stamp: 'HK 12/6/2010 12:47'!
defaultResponseId

	^ 0.! !

!S2JWebApp class methodsFor: 'configuration' stamp: 'HK 12/6/2010 13:51'!
defaultSuccessResponse

	^ 'success'! !

!S2JWebApp class methodsFor: 'accessing' stamp: 'HK 12/1/2010 22:44'!
globalResponseId
	^ globalResponseId! !

!S2JWebApp class methodsFor: 'accessing' stamp: 'HK 12/1/2010 22:44'!
globalResponseId: anObject
	globalResponseId := anObject! !

!S2JWebApp class methodsFor: 'configuration' stamp: 'LT 1/11/2011 17:56:56.376'!
graphicsCss

	^ 'http://dev.sencha.com/deploy/dev/resources/css/ext-all.css'! !

!S2JWebApp class methodsFor: 'convenience' stamp: 'HK 12/2/2010 13:18'!
increaseResponseId

	self globalResponseId: self globalResponseId + 1.! !

!S2JWebApp class methodsFor: 'configuration' stamp: 'HK 12/1/2010 20:47'!
inputPath

	^ '/put'.! !

!S2JWebApp class methodsFor: 'setup' stamp: 'HK 12/1/2010 21:32'!
isInstalled

	^ self site notNil.! !

!S2JWebApp class methodsFor: 'accessing' stamp: 'HK 12/7/2010 10:33'!
isServing
	^ isServing! !

!S2JWebApp class methodsFor: 'accessing' stamp: 'HK 12/7/2010 10:33'!
isServing: anObject
	isServing := anObject! !

!S2JWebApp class methodsFor: 'rendering javascript' stamp: 'ag 1/7/2011 21:33'!
javascriptBaseUrl
	"The global key #S2JJsBaseUrl is taken, if existing. Else, as default, the raw output of github is used."
	
	^ Smalltalk
		at: #S2JJsBaseUrl
		ifAbsent: [ self defaultJavascriptBaseUrl ]! !

!S2JWebApp class methodsFor: 'rendering javascript' stamp: 'ag 1/7/2011 21:33'!
javascriptBaseUrl: aString
	
	^ Smalltalk
		at: #S2JJsBaseUrl
		put: aString! !

!S2JWebApp class methodsFor: 'rendering javascript' stamp: 'LT 1/11/2011 17:43:21.595'!
javascriptGraphicsUrl
	"The global key #S2JJsBaseUrl is taken, if existing. Else, as default, the raw output of github is used."
	
	^ Smalltalk
		at: #S2JJsGraphicsUrl
		ifAbsent: [ self defaultJavascriptGraphicsUrl ]! !

!S2JWebApp class methodsFor: 'rendering javascript' stamp: 'LT 1/11/2011 17:42:49.163'!
javascriptGraphicsUrl: aString
	
	^ Smalltalk
		at: #S2JJsGraphicsUrl
		put: aString! !

!S2JWebApp class methodsFor: 'setup' stamp: 'HK 12/6/2010 12:44'!
prepareSite

	| site |
	site := SwazooSite newNamed: self siteName.
	site
		host: '*'
		ip: '*'
		port: self defaultPort;
		addResource: (self uriPattern: '/').
	self sessions: Dictionary new.
	^ site! !

!S2JWebApp class methodsFor: 'rendering javascript' stamp: 'ag 1/9/2011 14:11'!
recompileRequiredClasses
	"This causes all required classes of THIS web-app (none of the super-classes) to be invalidated in the code-factory-cache."
	
	^ self allRequiredClasses do: [ :each | each compileAll ]! !

!S2JWebApp class methodsFor: 'setup' stamp: 'HK 12/2/2010 11:28'!
removeSite

	SwazooServer singleton removeSite: self site.! !

!S2JWebApp class methodsFor: 'configuration' stamp: 'HK 12/6/2010 15:12'!
replacementDictionary

	^ Dictionary new
		at: '<' put: '%3C';
		at: '>' put: '%3E';
		yourself.! !

!S2JWebApp class methodsFor: 'rendering javascript' stamp: 'LT 1/11/2011 18:07:20.545'!
requiredClasses
	"Return any array of classes, that must be compiled to JS-code to enable this application.
	Classes added by subclasses must also return the classes in this implementation, as these clases are required by the js-bootstrapping-library."
	
	^ { BlockClosure. Float. True. False. Error. ByteString. OrderedCollection. Character. Array. Point }! !

!S2JWebApp class methodsFor: 'convenience' stamp: 'HK 12/2/2010 13:18'!
resetContent

	self
		globalResponseId: 0;
		responseContent: nil.
	self allInstances do: [ : each  | each localResponseId: 0 ]. ! !

!S2JWebApp class methodsFor: 'accessing' stamp: 'SW 12/1/2010 16:28'!
responseContent
	^responseContent
! !

!S2JWebApp class methodsFor: 'accessing' stamp: 'SW 12/1/2010 16:15'!
responseContent: anObject
	responseContent := anObject! !

!S2JWebApp class methodsFor: 'convenience' stamp: 'ag 1/3/2011 12:53'!
sendCode: content
	
	^ self updateResponseContentWithSqueakCode: content! !

!S2JWebApp class methodsFor: 'accessing' stamp: 'HK 12/6/2010 11:41'!
sessions
	^ sessions! !

!S2JWebApp class methodsFor: 'accessing' stamp: 'HK 12/6/2010 11:41'!
sessions: anObject
	sessions := anObject! !

!S2JWebApp class methodsFor: 'setup' stamp: 'HK 12/1/2010 21:32'!
site

	^ SwazooServer singleton siteNamed: self siteName.! !

!S2JWebApp class methodsFor: 'configuration' stamp: 'HK 12/1/2010 21:39'!
siteName

	^ 'S2JWebApp'.! !

!S2JWebApp class methodsFor: 'launch' stamp: 'LT 1/10/2011 14:55:42.405'!
startWebApp

	self isInstalled ifFalse: [ self prepareSite ].
	self isServing: true.
	self site start.! !

!S2JWebApp class methodsFor: 'convenience' stamp: 'HK 12/7/2010 16:49'!
toggleIsServing

	self isServing: self isServing not! !

!S2JWebApp class methodsFor: 'convenience' stamp: 'HK 12/2/2010 13:48'!
updateResponseContentWith: content

	self responseContent: content.
	self increaseResponseId.! !

!S2JWebApp class methodsFor: 'convenience' stamp: 'ag 1/3/2011 12:56'!
updateResponseContentWithSqueakCode: content

	| jsCode |
	[ jsCode := S2JPrinter convertDoIt: content ]
		on: Exception do: [ :err | jsCode := 'alert("Could not parse squeak-code: ', Character cr asString, content, Character cr asString, 'Error was: ', err asString, '");' ].
	self updateResponseContentWith: jsCode.! !

!S2JWebApp class methodsFor: 'rendering javascript' stamp: 'ag 1/9/2011 14:24'!
writeClassesTo: aDirectoryName
	"Write all classes required by this WebApp (together with their superclasses) to files named '<classname>.txt' in the given directory."
	
	self codeForAllClasses.
	self collectRequiredClasses withIndexDo: [ :cl :index |
		self codeFactory
			printCodeFor: cl
			to: aDirectoryName, index asString, '-', cl name, '.txt' ].! !

!S2JWebApp class methodsFor: 'rendering javascript' stamp: 'ag 1/9/2011 13:59'!
writeSiteTo: aLocalFilename
	"Write the website, that would be sent to a client, to a new file named aLocalFilename (overwrites existing)."
	
	^ self codeFactory converterClass
		print: self new renderWebsite
		to: aLocalFilename! !

!S2JWebApp class methodsFor: 'configuration' stamp: 'HK 12/1/2010 20:45'!
xmlPath

	^ '/xml'.! !

!S2JWebApp methodsFor: 'responding' stamp: 'HK 12/6/2010 13:39'!
answerContent: data withType: aString

	| response |
	response := HTTPResponse ok.
	^ response
		contentType: aString;
		entity: data;
		yourself.! !

!S2JWebApp methodsFor: 'responding' stamp: 'HK 12/7/2010 11:41'!
answerCreated

	^ HTTPResponse new code: 201.! !

!S2JWebApp methodsFor: 'responding' stamp: 'HK 12/7/2010 11:53'!
answerForbidden

	^ HTTPResponse forbidden.! !

!S2JWebApp methodsFor: 'responding' stamp: 'HK 12/7/2010 11:53'!
answerNoContent

	^ HTTPResponse new code: 204.! !

!S2JWebApp methodsFor: 'request handling' stamp: 'HK 12/7/2010 13:42'!
answerTo: aRequest 

	| resource response |
		
	resource := self identifierOf: aRequest.
	response := self handleRequest: aRequest for: resource.
	
	(self hasSession: aRequest) ifFalse: [ self startSessionWith: response.].
	
	^ response.! !

!S2JWebApp methodsFor: 'responding' stamp: 'HK 12/7/2010 13:42'!
answerWebsite

	^ self
		answerContent: self renderWebsite
		withType: 'text/html'.! !

!S2JWebApp methodsFor: 'responding' stamp: 'HK 12/7/2010 13:45'!
answerXmlDataTo: aRequest

	self increaseLocalResponseIdFor: aRequest.
	^ self
		answerContent: (self wrapUpAsXml: self class responseContent)
		withType: 'text/xml'.! !

!S2JWebApp methodsFor: 'synchronization' stamp: 'HK 12/6/2010 13:47'!
clientIsBehindWith: aRequest

	^ self class globalResponseId > (self localResponseIdFor: aRequest).! !

!S2JWebApp methodsFor: 'rendering' stamp: 'ag 1/7/2011 21:19'!
cr
	
	^ Character cr asString! !

!S2JWebApp methodsFor: 'rendering' stamp: 'HK 12/7/2010 18:04'!
cssData 

	^ 'body {
		font-family: Verdana;
		margin: 0px;
		padding: 0px;
	}
	
	#container {
		width: 80%;
		margin: 0px auto;
	}
	
	textarea {
		width: 100%;
		background-color: #F9F7ED;
		border: 1px solid #4096EE;
	}
	
	table {
		width: 100%;
	}
	
	th {
		text-align: left;
		width: 45%;
	}

	tr th:first-child {
		width: 10%;	
	}
	
	.red {
		background-color: #D15600;
	}
	
	.yellow {
		background-color: #FFFF88;
	}
	
	.green {
		background-color: #6BBA70;
	}'.! !

!S2JWebApp methodsFor: 'rendering javascript' stamp: 'LT 1/11/2011 18:03:38.922'!
externalGraphicsJavascriptUrls
	
	^ #( 'ext-all-debug.js' 'adapter/ext/ext-base.js' 'ext-all-debug.js' )! !

!S2JWebApp methodsFor: 'rendering javascript' stamp: 'ag 1/11/2011 17:20'!
externalJavascriptUrlsAfterClasses

	^ #( 'bootstrap.js' 'kernel_primitives.js' )! !

!S2JWebApp methodsFor: 'rendering javascript' stamp: 'ag 1/11/2011 17:21'!
externalJavascriptUrlsBeforeClasses
	
	^ #( 'squeaky.js' 'bidirectional_communication.js' )! !

!S2JWebApp methodsFor: 'request handling' stamp: 'HK 12/7/2010 11:40'!
handleInputOf: aRequest

	| content |
	content := self postDataOf: aRequest.
	content ifNotNil:
		[self increaseLocalResponseIdFor: aRequest.
		self class updateResponseContentWith: content].
	^ self answerCreated.! !

!S2JWebApp methodsFor: 'request handling' stamp: 'HK 12/7/2010 13:43'!
handleRequest: aRequest for: aResource

	aResource = self class applicationPath ifTrue: [ ^ self answerWebsite ].
	aResource = self class xmlPath ifTrue: [ ^ self handleXmlRequest: aRequest ].
	aResource = self class inputPath ifTrue: [ ^ self handleInputOf: aRequest ].
	^ self redirectToHome.
	
	! !

!S2JWebApp methodsFor: 'request handling' stamp: 'HK 12/7/2010 14:08'!
handleXmlRequest: aRequest

	^ (self hasNewDataFor: aRequest)
		ifTrue: [ self answerXmlDataTo: aRequest ]
		ifFalse:
			[ self suspendRequestAndExecute:
				[ ^ self handleXmlRequest: aRequest ]].! !

!S2JWebApp methodsFor: 'synchronization' stamp: 'HK 12/6/2010 13:47'!
hasNewDataFor: aRequest

	self class responseContent ifNil: [ ^ false ].
	(self hasSession: aRequest) ifFalse: [ ^ true ].
	^ self clientIsBehindWith: aRequest.! !

!S2JWebApp methodsFor: 'session management' stamp: 'HK 12/6/2010 14:23'!
hasSession: aRequest

	^ aRequest cookie notNil and: [ self class sessions includesKey: (aRequest cookie asNumber) ].! !

!S2JWebApp methodsFor: 'rendering' stamp: 'HK 12/1/2010 22:00'!
htmlDocumentType

	^ '<!!DOCTYPE html>'.! !

!S2JWebApp methodsFor: 'convenience' stamp: 'SW 12/1/2010 16:08'!
identifierOf: aRequest

	^ aRequest requestLine requestURI identifier.! !

!S2JWebApp methodsFor: 'session management' stamp: 'HK 12/7/2010 10:46'!
increaseLocalResponseIdFor: aRequest

	self class sessions at: (aRequest cookie asNumber) put: self class globalResponseId.
	Transcript show: 'Client #', aRequest cookie, ' is now at ', self class globalResponseId asString; cr.! !

!S2JWebApp methodsFor: 'session management' stamp: 'HK 12/6/2010 13:24'!
localResponseIdFor: aRequest

	^ self class sessions at: (aRequest cookie asNumber).! !

!S2JWebApp methodsFor: 'convenience' stamp: 'HK 12/2/2010 10:50'!
postDataOf: aRequest

	aRequest isPostDataEmpty ifTrue: [ ^ nil ].
	^ aRequest postData keys any.! !

!S2JWebApp methodsFor: 'request handling' stamp: 'HK 12/2/2010 15:23'!
redirectToHome

	| response |
	response := HTTPResponse redirectLink.
	^ response
		location: self class applicationPath;
		yourself.! !

!S2JWebApp methodsFor: 'rendering' stamp: 'ag 1/6/2011 22:19'!
renderAdditionalContent
	"For subclasses to add custom content to the page"
	
	^ ''! !

!S2JWebApp methodsFor: 'rendering' stamp: 'ag 1/7/2011 21:46'!
renderBody

	^ '<body><div id="container">', self cr,
	self renderAdditionalContent, self cr,
	self renderContent, self cr,
	'</div></body>'! !

!S2JWebApp methodsFor: 'rendering' stamp: 'ag 1/7/2011 21:47'!
renderContent

	^ '<h3>Post code</h3>
	<p><textarea id="input"></textarea></p>
	<p><input type="button" value="Send data" onclick="send();"></p>
	<h3>Log</h3>
	<p>
	<input type="button" value="Start polling" onclick="poll();">
	<input type="button" value="Stop polling" onclick="stop();">
	<input type="button" value="Clear log" onclick="clearLog();">
	</p>
	<table>
	<thead>
	<tr>
	<th>HTTP</th>
	<th>Log</th>
	<th>Eval</th>
	</tr>
	</thead>
	<tbody>
	</tbody>
	</table>
	</div>'! !

!S2JWebApp methodsFor: 'rendering' stamp: 'LT 1/11/2011 18:17:20.327'!
renderHeader

	^
	'<head>', self cr,
		'<title>',
			self class siteName,
		'</title>', self cr,
		'<style type="text/css">',
			'<!!--', self cssData, '-->',
		'</style>', self cr,
		'<style type="text/css" src=',self class graphicsCss,'>',
		'</style>', self cr,
		self renderJavascript,
	'</head>'! !

!S2JWebApp methodsFor: 'rendering javascript' stamp: 'LT 1/11/2011 17:40:12.664'!
renderJavascript
	"Render the external javascript resources and the javascript code compiled from image-code."
	
	^
	(self renderScriptTags: self externalJavascriptUrlsBeforeClasses forUrl: self class javascriptBaseUrl),
	(self renderScriptTags: self externalGraphicsJavascriptUrls forUrl: self class javascriptGraphicsUrl),
	'<script type="text/javascript">', self cr,
		self class codeForAllClasses, self cr,
	'</script>', self cr,
	(self renderScriptTags: self externalJavascriptUrlsAfterClasses forUrl: self class javascriptBaseUrl)! !

!S2JWebApp methodsFor: 'rendering javascript' stamp: 'LT 1/11/2011 17:37:59.132'!
renderScriptTags: aCollectionOfFilenames forUrl: aString
	"aCollectionOfFilenames does not contain absolute Urls, but only the filenames of the js-files. The path (url) will be prepended."
	
	^ aCollectionOfFilenames
		inject: ''
		into: [ :string :eachUrl |
			string, '<script type="text/javascript" src="', aString, eachUrl, '"></script>',
			self cr ]! !

!S2JWebApp methodsFor: 'rendering' stamp: 'ag 1/7/2011 21:48'!
renderWebsite
	
	^ self htmlDocumentType, self cr,
	'<html>', self cr,
		self renderHeader, self cr,
		self renderBody, self cr,
	'</html>'! !

!S2JWebApp methodsFor: 'session management' stamp: 'HK 12/7/2010 11:04'!
startSessionWith: aResponse

	| randomId |
	[ randomId := 10e10 atRandom ] doWhileTrue:
		[ self class sessions includesKey: randomId ].
	self class sessions at: randomId put: self class defaultResponseId.
	aResponse cookie: randomId asString.
	
	Transcript show: 'Starting session #', randomId asString; cr.! !

!S2JWebApp methodsFor: 'comet' stamp: 'HK 12/7/2010 14:07'!
suspendRequestAndExecute: aBlock
	
	self class isServing ifFalse: [ ^ self answerNoContent ].
	
	self wait.	
	^ aBlock value.! !

!S2JWebApp methodsFor: 'comet' stamp: 'HK 12/7/2010 13:47'!
wait

	(Delay forMilliseconds: self class defaultMillisecondsToWait) wait.! !

!S2JWebApp methodsFor: 'comet' stamp: 'HK 12/7/2010 13:47'!
waitForMilliseconds: milliseconds

	(Delay forMilliseconds: milliseconds) wait.! !

!S2JWebApp methodsFor: 'convenience' stamp: 'HK 12/6/2010 15:12'!
withEncodedUriComponents: contentString

	| temporaryString |
	temporaryString := contentString.
	
	self class replacementDictionary keysAndValuesDo:
		[ :key :value |
			temporaryString := temporaryString copyReplaceAll: key with: value ].

	^ temporaryString.! !

!S2JWebApp methodsFor: 'convenience' stamp: 'HK 12/2/2010 18:53'!
wrapUpAsXml: content

	^ self xmlDocumentType, '<data>', (self withEncodedUriComponents: content), '</data>'.! !

!S2JWebApp methodsFor: 'rendering' stamp: 'HK 12/2/2010 00:16'!
xmlDocumentType

	^ '<?xml version="1.0"?>'.
! !
